<?php
    include_once('netphp/src/Core/ComProxy.php');
    include_once('netphp/src/Core/NetProxy.php');
    include_once('netphp/src/Core/MagicWrapper.php');
    include_once('netphp/src/Core/NetPhpRuntime.php');

    try 
    {
        $rt = new \NetPhp\Core\NetPhpRuntime('COM', 'netutilities.NetPhpRuntime');
        $rt->Initialize();
        $rt->RegisterNetFramework4();
        $rt->RegisterAssemblyFromFile("MT4ServerAPI.dll", "MT4ServerAPI");
        
        $from = $rt->TypeFromName("System.DateTime")->Now->AddMonths(-1);
        echo $from->ToString()->Val()."\n";
        $to = $rt->TypeFromName("System.DateTime")->Now->AddDays(1);
        echo $to->ToString()->Val()."\n";

        $qcStatic = $rt->TypeFromName("TradingAPI.MT4Server.QuoteClient");
        //$intptr = $rt->TypeFromName("System.IntPtr");
        //$intptr->Init(230259878);//$intptr->ToInt32()>Val()
        $qc = $qcStatic->GetQuoteClient(230259878, "pjO5iuEF", "FBS-Real-3.srv", $from, $to);
        echo "Account balance = ".$qc->AccountBalance->Val()."\n";
        $qc->Subscribe("EURUSD");
        while ($qc->GetQuote("EURUSD")->Val() == null) 
        {
        }
        $ask = $qc->GetQuote("EURUSD")->GetAsk()->Val();
        echo "EURUSD Ask = ".$ask."\n";

        $orders = $qc->GetOpenedOrders();
        echo "Opened orders count ".$orders->Length->Val()."\n";
        for ($i = 0; $i < $orders->Length->Val(); $i++) {
            $order = $orders->GetValue($i)->Val();
            echo $order->Ticket." ";
            echo $order->Symbol." ";
            echo $order->OpenPrice."\n";
        }
        
        $orders = $qc->ClosedOrders;
        echo "Closed orders from ".$from->ToString()->Val()." to ".$to->ToString()->Val()." count ".$orders->Length->Val()."\n";
        for ($i = 0; $i < $orders->Length->Val(); $i++) {
            $order = $orders->GetValue($i)->Val();
            echo $order->Ticket." ";
            echo $order->Symbol." ";
            echo $order->OpenPrice."\n";
        }

        //$oc = $rt->TypeFromName("TradingAPI.MT4Server.OrderClient");
        //$oc->Instantiate();
        //$oc->Init($qc);
        //$oc->Connect();
        //$op = $rt->TypeFromName("TradingAPI.MT4Server.Op");
        //Trading functionnality not avaliable in trial version
        //$order = $oc->OrderSend("EURUSD", $op->Enum("Buy"), 0.1, $ask, 0, 0.0, 0.0);
        //echo "Order opened ".$order->ToString()->Val();

    } catch (Exception $e) 
    {
        echo $e->getMessage();
    }
?>